/*
 * File:   main.c
 * Author: Renato Ferrero
 *
 * Created on 09 febbraio 2014, 17.37
 */

#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include "PIC18F4550_config.h"

#define LCD_DEFAULT
#include <delay.h>
#include <delay.c>
#include <LCD_44780.h>
#include <LCD_44780.c>


#include<usart.h>

#define Cicalino LATCbits.LATC0  
#define KeyGsmOn LATEbits.LATE0  
#define LedVerde LATEbits.LATE1
#define LedRosso LATEbits.LATE2
#define PulsanteBT1 PORTBbits.RB4 // Pulsante BT1
#define PulsanteBT2 PORTBbits.RB5 // Pulsante BT2

unsigned char Beep(int, unsigned char); // funzione per cicalino
unsigned char InviaStrUSART(char*);

void main(void) {

    LATA = 0x00;
    TRISA = 0b11111111; // imposta pin come output=0 ...input=1
    // imposta pin come output se 0 ...o come input se 1
    PORTB = 0x00;
    TRISB = 0b11111111;
    LATC = 0x00;
    TRISC = 0b00000000;
    // Imposto PORTD tutte uscite
    LATD = 0x00;
    TRISD = 0b00000001;
    // Imposto PORTE tutte uscite
    LATE = 0b00000000;
    TRISE = 0b00000000;
    KeyGsmOn = 1;
    LedVerde = 1;
    LedRosso = 1;

    //Apro porta USART a 9600 baud
    OpenUSART(USART_TX_INT_OFF &
            USART_RX_INT_ON &
            USART_ASYNCH_MODE &
            USART_EIGHT_BIT &
            USART_CONT_RX &
            USART_BRGH_HIGH, 129); //baud:9600=129  115200=10

    INTCON2bits.RBPU = 0; // abilito i resistori di pull-up su PORTB

    OpenLCD(20);
    delay_ms(200);
    write_message_LCD("Programma esempio");
    goto_line_LCD(2);
    WriteStringLCD("Test_putrsUSART");
    Beep(50
            , 1);
    backlight_LCD(TURN_ON_LED_LCD);
    delay_s(1);
    LedRosso = 0;
    LedVerde = 0;
    ClearLCD();
    WriteStringLCD("BT1:InvioStrUSART");
    goto_line_LCD(2);
    WriteStringLCD("BT2:PutrsUSART");
    Beep(50, 3);
    delay_s(1);

    backlight_LCD(TURN_OFF_LED_LCD);



    while (1) {
        //*********************CONTROLLO OVERFLOW MODULO USART

        if (PulsanteBT1 == 0) {
            delay_ms(20);
            if (PulsanteBT1 == 0) {
                Beep(50, 1);
                InviaStrUSART((char *) "AT\r\n");
                ClearLCD();
                WriteStringLCD(" InviaStrUSART");
                goto_line_LCD(2);
                WriteStringLCD("   AVVENUTO");
                while (PulsanteBT1 == 0) {
                    // attende che si rilasci BT1
                }
                delay_ms(900);
            }
            ClearLCD();
            WriteStringLCD("BT1:InvioStrUSART");
            goto_line_LCD(2);
            WriteStringLCD("BT2:PutrsUSART");
        }
        if (PulsanteBT2 == 0) {
            delay_ms(20);
            if (PulsanteBT2 == 0) {

                Beep(100, 1);
                putrsUSART((char*) "AT\r\n");
                ClearLCD();
                WriteStringLCD("  PutrsUSART");
                goto_line_LCD(2);
                WriteStringLCD("   AVVENUTO");
                while (PulsanteBT2 == 0) { // attende che si rilasci BT2
                }
                delay_ms(900);
            }

            ClearLCD();
            WriteStringLCD("BT1:InvioStrUSART");
            goto_line_LCD(2);
            WriteStringLCD("BT2:PutrsUSART");

        }



    }
}
//*************************************************************
//            INVIA STRINGA SU USART
//*************************************************************

unsigned char InviaStrUSART(char* StrUsart) {
    unsigned char x6 = 0;
    while (StrUsart[x6] != '\0') {
        WriteUSART(StrUsart[x6]);
        delay_ms(10);
        x6++;
    }
    return (0);
}


//****************************************************
//    BEEP
//******************************************************

unsigned char Beep(int Durata, unsigned char NumVolte) {
    unsigned char a = 0;
    for (a = 0; a < NumVolte; a++) {
        Cicalino = 1;
        delay_ms(Durata);
        Cicalino = 0;
        delay_ms(100);
    }
    return (1);
}


